// compproc.h

#ifndef _COMPPROC_H_
#define _COMPPROC_H_

#include "interface.h" // which may or may nor #define LiDIA
                       // and sets up common interface

inline int is_real(const bigcomplex& z) {return(is_approx_zero(imag(z)));}
 
const bigcomplex eye = bigcomplex(0,1);

inline int is_small(bigfloat x) {return is_approx_zero(x);}
inline int is_small(const bigcomplex& z){return is_approx_zero(z);}

void orderreal(bigfloat& e1, bigfloat& e2, bigfloat& e3);  // puts in decreasing order
bigcomplex root(const bigcomplex& z, int n);
bigcomplex cagm(const bigcomplex& a, const bigcomplex& b);
bigcomplex normalize(bigcomplex& w1, bigcomplex& w2);
void getc4c6(const bigcomplex& w1, const bigcomplex& w2, bigcomplex& c4, bigcomplex &c6);
bigcomplex discriminant(const bigcomplex& b, const bigcomplex& c, const bigcomplex& d);
bigcomplex* solvecubic(const bigcomplex& c1, const bigcomplex& c2, const bigcomplex& c3);
bigcomplex* solvequartic(const bigcomplex& a, const bigcomplex& b, const bigcomplex& c, const bigcomplex& d);
bigcomplex* solverealquartic(const bigfloat& a, const bigfloat& b, const bigfloat& c, const bigfloat& d, const bigfloat& e);

int norepeats(long* x, int n);
long* introotscubic(long a, long b, long c, int& nr);
void quadsolve(const bigfloat& p, const bigfloat& q, bigcomplex& root1,bigcomplex& root2);

#endif
