//
// findinf.cc -- to find infinite points up to naive height,
//               giving a Z-basis for E(Q)/T [or a subset, if
//               search bound is user-set low]
//
// written as a subroutine; could be moved to a header/.cc

#include "mwprocs.h"

int main()
{
#ifdef LiDIA
  long ndp=15;
//  cout<<"Enter number of decimal places: "; cin>>ndp;
  bigfloat::precision(ndp);
  cout << "Working to "<<ndp<<" decimal places " << endl;
#endif
  initprimes("PRIMES",1);

  bigfloat reg, ht_limit;
  int verbose = 1, modopt=2, pp=1; 
  long blength, rank;
  cout<<"\nenter search limit: ";      cin>>ht_limit;
  cout<<"verbose (0/1)? ";             cin >>verbose;
  cout<<"process points found (1) or just list them (0): "; cin>>pp;
  //  cout<<"moduli option (1/2/3)?";      cin >> modopt;
  Curve E;

  while (1)
    {
      cout<<"\nInput a curve: ";      cin >> E;
      if ( E.isnull() ) break;
      Curvedata C(E);
      cout << "Curve " << (Curve)C << endl;
      Point P(C);
      cout<<"enter number of known points: ";      cin >>blength;
      PointArray known_points(blength);
      if (blength)
	{ 
	  for (long j=0; j<blength; j++)
	    { cout<<"\n  enter point "<<(j+1)<<" : ";
	      cin >> P;
	      if ( P.isvalid() ) known_points[j]=P;
	      else {cout<<" whoops! bad point. Start all over again.\n\n"; break; }
	    }
	}

      mw mwbasis(&C, verbose, pp);
      if(blength)
	{
	  mwbasis.process(known_points);
	  rank = mwbasis.getrank();
	  cout<<"Rank of known points is "<<rank<<endl;
	  cout<<"\nregulator is "<<mwbasis.regulator()<<endl<<endl;
	}

      mwbasis.search(ht_limit, modopt, verbose);

      if(pp){
      rank = mwbasis.getrank();
      cout<<"Rank of points found is "<<rank<<endl;
      PointArray b = mwbasis.getbasis();
      for (long i=0; i<rank; i++)
	{ P = b[i];
	  cout << "\tGenerator "<<(i+1)<<" is "<<P<<"; ";
	  cout << "height "<<height(P)<<endl;
	}
      if(rank>1) cout<<"\t\tregulator is "<<mwbasis.regulator()<<endl;
      cout<<endl;
    }
    }
}

//end of file findinf.cc





