#include <math.h>
#include "log2.h"


// Function which returns 1 and sets e such that 2**e=n if n is a power of 2.
// If the "roundup" flag is set and n is not a power of 2 it increases n to
// the next power of 2 (and returns 0)

int intlog2(long& n, long& e, int roundup)
{ 
  e = 0;

  if (n<1) {if(roundup) n=1; return 0;}
  long m=n;
  while (!(m&1)) {m>>=1; e++;}
  if (m==1) return 1;
  if(roundup)
    {
      e=(long)ceil(log(double(n)/M_LN2));
      n=1<<e;
    }
  return 0;
}

