class rank2 { // class to do 2-descent via 2-isogeny
private:
  bigintArray badprimes, elsgens0, elsgens1, glsgens0, glsgens1, supp0, supp1;  
  int verbose, success, certain;
  long rank, rank_bound, index2;
  long nt2gens0, nt2gens1, lim2, mask0, mask1;
  long els0, els1, gls0, gls1;   // after first descent
  long els20, els21, gls20, gls21;   // after second descent
  int d_is_sq, ddash_is_sq;
  bigint e2, e3, e2dash, e3dash;
  bigint lim1;
  Curvedata *the_curve, ee, eedash;
  PointArray pointlist, fullpointlist, two_torsion;  
  int npoints, npoints1, fullnpoints, ntwo_torsion;;
public: 
  rank2(Curvedata* ec, int verb, long l1=20, long l2=5);
// firstlim  is (bigint) bound on |x|+|z|
// secondlim is (double) bound on log max {|x|,|z| }, i.e. logarithmic
  int getrank()    const { return rank; }
  long getrank_ub() const {return rank_bound;}
  long getcertain()  const {return certain;}
  int ok()         const { return success; }
  void listgens();
  void listgens(Curvedata* CD_orig, const bigint& u, const bigint& r, 
		const bigint& s, const bigint& t);
  void listpoints();
  void listpoints(Curvedata* CD_orig, const bigint& u, const bigint& r, 
		  const bigint& s, const bigint& t);
  PointArray getpoints() const {return fullpointlist;}
  PointArray getgens() const {return pointlist;}
  void makepoints();
private:
  int testquartic(const bigint& c, const bigint& d1, const bigint& d2, int which);
  int second_descent(const bigint& c, const bigint& d1, const bigint& d2, int which);
  void makepoint(const bigint& c, const bigint& d1, const bigint& d2, 
		 const bigint& x, const bigint& y, const bigint& z, 
		 int which);
  void find_elsgens(int which, const bigint& c, const bigint& d);
  void find_glsgens(int which, const bigint& c, const bigint& d);
  void makegens();
};

