#include "marith.h"
#include "conic.h"

void testmodsqrt()
{
  long i,m;
  int res, ok=1;
  bigint a,mm,x;
  cout << "Enter a modulus m: ";
  cin >> m; mm=m;
  bigintArray plist=pdivs(mm);
  int* flag = new int[m];
  for(i=0; i<m; i++) flag[i]=0;
  for(i=0; i<=m/2; i++) flag[(i*i)%m]=1;
  for(i=0; i<m; i++) 
    {
      a=i; //      cout<<"a = "<<a;

      res = modsqrt(a,plist,x);
#if(0)
      if(res)
	{
	  cout << "\tsqrt(a) mod m = " << x;
	  if((x*x-a)%mm==0) cout<<" --checks.";
	  else cout << "--WRONG!";
	}
      else 
	{
	  cout << "\tNo solution";
	}
#endif
      if(res!=flag[i]) 
	{
	  cout << "WRONG ANSWER for a="<<a<<endl;
	  ok=0;
	}
    }
  if(ok) cout << "All correct" << endl;
}

void testsqf()
{
  long i;
  int res, ok=1;
  bigint a,m,m1,m2;
  bigintArray plist;
  while(cout << "Enter a nonzero integer m: ",  cin >> m, m!=0)
    {
      sqfdecomp(m,m1,m2,plist);
      cout << "sqfdecomp returns m1 = " << m1 << " and m2 = " << m2 << endl;
      cout << "(plist = " << plist << ")\n";
      sqfdecomp(m,plist,m1,m2);
      cout << "sqfdecomp returns m1 = " << m1 << " and m2 = " << m2 << endl;
      cout << "(plist = " << plist << ")\n";
    }
}

void testcancel()
{
  bigint x,y,z;
  cout << "Enter x, y, z to be cancelled: ";
  cin >> x >> y >> z;
  cout << "Before: (x:y:z) = ("<<x<<":"<<y<<":"<<z<<")\n";
  cancel(x,y,z);
  cout << "After:  (x:y:z) = ("<<x<<":"<<y<<":"<<z<<")\n";
}

main()
{
  initprimes(1000000);
  bigint a,b,c,d,x,y,z;
  while(1) {
  cout << "Enter coefficients a b c d: ";
  cin >> a >> b >> c >> d;
  cout<<a<<" "<<b<<" "<<c<<" "<<d<<endl; 
  if(d==0) {break;}
  int res = solve_conic(a,b,c,d,x,y,z);
  if(res) 
    {
      cout << "Solution: (x:y:z) = ("<<x<<":"<<y<<":"<<z<<")\n";
      testsol(a,b,c,d,x,y,z,1);
    }
  else cout << "No solution.\n";
}
}



