/* TMRANK.CC:  main program; calls mrank1 and/or mrank2  */
/*   (test version: reads right answer from file too) */
                                                  
#include "points.h"  // from qcurves library
#include "mquartic.h"
#include "mequiv.h"
#include "msoluble.h"
#include "mrank1.h"
#include "mrank2.h"
#include "version.h"
#include "timer.h"

bigint a1,a2,a3,a4,a6;
Curve C;
Curvedata CD;
int verbose;
long hlimq=5; 
long naux=-1;

int getcurve(void)
{
  if (verbose) cout << "Enter curve coefficients a1,a2,a3,a4,a6 ?" << "\n";
  cin >> a1 >> a2 >> a3 >> a4 >> a6;
  C = Curve(a1,a2,a3,a4,a6);
  CD = Curvedata(C,1);     // "1" means minimise
  return (a1!=0||a2!=0||a3!=0||a4!=0||a6!=0);
}

int main()
{
  show_version();
#ifdef LiDIA
  long lidia_precision=20;
  //  cout<<"Enter number of decimal places: "; cin>>lidia_precision;
  bigfloat::precision(lidia_precision);
#else
  cout.precision(15);
#endif
  init_time();

  cout << "Verbose mode? (0/1)\n"; cin >> verbose;
  initprimes("PRIMES",verbose);
//  cout << "Number of sieving primes? (e.g. 4, max = 15)\n"; cin >> naux;
  cin.flags( cin.flags() | ios::dec );  //force decimal input (bug fix)
  while (getcurve())
    {
      int filerank;  // for testing
      cin >> filerank;
      if(verbose) cout<<"\n\n";
      cout << "Curve "<< C << " :  ";
      if (verbose) cout << endl; else cout<<flush;
      long rank;
      int success;
 
      start_time();
      rank2 r2(&CD, verbose, 2, hlimq);
      stop_time();
 
      if (r2.ok())
        {   
          rank=r2.getrank();
          cout << "Rank = " << rank;
	  show_time();
          if (rank!=filerank) cout << "Wrong! Should be " << filerank << endl;
        }
      else
        {
	  start_time();
          rank1 r1(&CD, verbose, 0, 2, hlimq, naux);
	  stop_time();

          if (r1.ok())
            {    
              rank=r1.getrank();
              cout << "Rank = " << rank;
	      show_time();
              if (rank!=filerank) cout << "Wrong! Should be " << filerank << endl;
            }
          else cout << "Failed to compute rank\n";
        }
    }
}
