//
// twist.cc -- program to display twisted curves E * twist
//

#include "curve.h"

main(){

initprimes("PRIMES",1);

Curve F;
Curvedata D, E;
CurveRed CR;
bigint c4,c6,twist2;


while (cout << "\nEnter a  curve: ",
       cin >> F,
       !F.isnull() )
{
  D = Curvedata(F,1); // construct as minimal
  E = D;
  CR = CurveRed(E);
  cout << "\nCurve is:  " << endl;  CR.display(cout);
  
  long twist=1;
  
  while(  cout << "\nEnter a twist value: ",
	cout << "\n(0 to set a new `original' curve, 1 to twist original,\n",
	cout << "or any other integer to twist immediately preceding output) ",
	cin >> twist,
	(twist|=0))
    {
      if(twist==1) { E=D;}
      else
	{
	  E.getci(c4, c6);
	  twist *= 4;        //corrects for twist not congruent -1 mod 4
	  twist2 = twist*twist;
	  c4 *= twist2;
	  c6 *= twist*twist2;
	  E = Curvedata(Curve(c4, c6), 1); //minimal form
	  CR=CurveRed(E);
	  cout << "\n\nE * " << twist/4 << " is:  \n"; CR.display(cout); 
	  cout << endl;
	}
    }
}


} //ends main
